<?php


namespace app\admin\controller;


use think\App;
use think\facade\Db;

class Purch extends \app\BaseController
{
    public $post="";
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post=$this->request->post();

    }

    public function  list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where =['is_del'=>0];
        $bkcode = isset($this->post['bk_code']) && $this->post['bk_code']!="" ? trim($this->post['bk_code']):"";
        if($bkcode!=""){
            $where['bkcode'] = $bkcode;
        }
        $wsm_in_code = isset($this->post['wsm_in_code']) && $this->post['wsm_in_code']!="" ? trim($this->post['wsm_in_code'])
            :"";
        if($wsm_in_code!=""){
            $where['wsm_in_code'] = $wsm_in_code;
        }

        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name']!="" ? trim($this->post['apply_name']):"";
        if($apply_name!=""){
            $where['apply_name'] =Db::Raw("like '%{$apply_name}%'");
        }
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code!=""){
            $where['wsm_code'] = $wsm_code;
        }
        $good_name = isset($this->post['status']) && $this->post['status']!="" ? trim($this->post['status']):"";
        if($good_name!=""){
            $where['good_name'] = Db::raw(" like %{$good_name}%");
        }
        $count=Db::name("purchease_order")->where($where)->count();
        $total = ceil($count/$size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name("purchease_order")->where($where)->page($page,$size)->select();
        return app_show(0,"获取成功",["list"=>$list,"count"=>$count]);
    }
}